/*
 * Copyright (C) 2009 Yoonsuck Choe
 * 
 * This file is an add-on to ANJI (Another NEAT Java Implementation).
 * This add-on has the same terms and conditions as ANJI (see below).
 * 
 * Fri Nov 27 23:19:12 CST 2009
 *----------------------------------------------------------------------------
 * ANJI is free software; you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307 USA
 *
 */
package com.anji.navi;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

import java.awt.event.ActionEvent;

import java.util.Random;
import java.util.Collections;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.ListIterator;

public class TSDisplay extends JPanel{
    private int    width;
    private int    height;
    private Graphics2D naviG;
    private Color[] pallett;
    private Color[] shortPallett;
    private Color[] grayPallett;
    private Color[] pallettType;
    private Color goalColor;
    private Color startColor;
    private int pallettSize;
    private final static char TSOBJ_CIRCLE = 'c';
    private final static char TSOBJ_LINE = 'l';

    private class TSObj {

	double x;
	double y;
	double x2;
	double y2;
	Color c;
	double r;
	double e;
	float w;
	char type;

	TSObj (double px, double py, Color pc, double pr) {
		x = px;
		y = py;
		c = pc;
		r = pr;
		e = 1.0;
		w = 1.0f;
		type = TSOBJ_CIRCLE;
	}

	TSObj (double px, double py, Color pc, double pr, double pe) {
		x = px;
		y = py;
		c = pc;
		r = pr;
		e = pe;
		w = 1.0f;
		type = TSOBJ_CIRCLE;
	}

	TSObj (double px1, double py1, double px2, double py2, Color pc,
		float pw) {
		x = px1;
		y = py1;
		x2 = px2;
		y2 = py2;
		c = pc;
		w = pw;
		type = TSOBJ_LINE;
	}

    }

    private List<TSObj> objList;
    private List<TSObj> lineList;

    TSDisplay (int w, int h) {

	width = w;
	height = h; 

	objList = new ArrayList<TSObj>(1000);
	lineList = new ArrayList<TSObj>(1000);

	// set up pallett for trajectory
	pallett = new Color[256*3];
	for (int i=0; i<256; ++i) {
		pallett[i] = new Color(i,0,0);
		pallett[i+255] = new Color(255,i,0);
		pallett[i+255*2] = new Color(255,255,i);
	}

	shortPallett = new Color[256];
	for (int i=0; i<86; ++i) {
		shortPallett[i] = new Color(i*3,0,0);
		shortPallett[i+85] = new Color(255,i*3,0);
		shortPallett[i+85*2] = new Color(255,255,i*3);
	}
	
	grayPallett = new Color[128];
	for (int i=0; i<128; ++i) {
		grayPallett[i] = new Color(i,i,i);
	}

	pallettType = shortPallett;
        pallettSize = 256;
	
	goalColor = new Color(0,255,0);
	startColor = new Color(255,0,0);

	/*
	Action actionListener = new AbstractAction() {
      	    public void actionPerformed(ActionEvent actionEvent) {
        	System.out.println("Got an q");
      	    }	
   	};
	*/

	// set up frame
	JFrame frame = new JFrame("TSDisplay");
	frame.setContentPane(this);
	Container con = frame.getContentPane();
	//frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	con.setBackground(Color.gray);
	//KeyStroke stroke = KeyStroke.getKeyStroke("q");
	//InputMap inputMap = ((JPanel)con).getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
        //inputMap.put(stroke, "OPEN");
        //((JPanel)con).getActionMap().put("OPEN", actionListener);
	frame.setSize(w+10,h+25);
	frame.setLocationRelativeTo(null);
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	frame.setVisible(true);

    }

    public void moveTo(double x, double y) {
	BasicStroke stroke = new BasicStroke(3.0f);
	naviG.setStroke(stroke);
	//double next_x = rangeCheck(cur_x + x);
	//double next_y = rangeCheck(cur_y + y);
	//naviG.drawLine((int)(cur_x*width),(int)(cur_y*height),
	//	(int)(next_x*width),(int)(next_y*height));
	//cur_x = next_x;
	//cur_y = next_y;
    }

    public void fromTo(double x, double y, double x2, double y2) {
	BasicStroke stroke = new BasicStroke(3.0f);
	naviG.setStroke(stroke);
	naviG.drawLine((int)(x*width),(int)(y*height),
		(int)(x2*width),(int)(y2*height));
    }

    public void plotLoc(double x, double y, Color c) {
	plotLoc(x,y,c,1.0);
    }

    public void plotLine(double x, double y, double x2, double y2, Color c,
		float w) {
	BasicStroke stroke = new BasicStroke(w);
	naviG.setStroke(stroke);
	naviG.setColor(c);
	naviG.drawLine((int)(x*(double)width),(int)(y*(double)height),
		(int)(x2*(double)width),(int)(y2*(double)height));
    }

    public void plotLoc(double x, double y, Color c, double r) {
	double offset = 3.0/width;
	naviG.setColor(c);
	naviG.fillOval(
		(int)((x)*width-r*width/40.0/2.0),
		(int)((y)*height-r*height/40.0/2.0),
		(int)(r*width/40.0),(int)(r*height/40.0));
    }

    public void plotStart(double x, double y) {
	plotLoc(x,y,startColor);
    }

    public void plotGoal(double x, double y) {
	plotLoc(x,y,goalColor);
    }

    public double rangeCheck(double x) {
	if (x < 0.0) return 0.0;
	if (x >= 1.0) return 1.0;
	return x;
    }
   
    public static double naviRangeCheck(double x) {
	if (x < 0.0) return 0.0;
	if (x >= 1.0) return 1.0;
	return x;
    }

    public void addObj(double x, double y, Color c) {
	addObj(x,y,c,1.0,1.0);
    }

    public void addObj(double x, double y, Color c, double r, double e) {
	TSObj ts = this.new TSObj(x,y,c,r,e);
	synchronized(objList) {
	  objList.add(ts);
	}
	repaint();
    }

    public void addLine(double x1, double y1, double x2, double y2, Color c,
		float w) {
	TSObj ts = this.new TSObj(x1,y1,x2,y2,c,w);
	synchronized(lineList) {
	  lineList.add(ts);
	}
	repaint();
    }

    public void clearList() {
	synchronized(objList) {
	  objList.clear();
	}
	repaint();
    }

    public void clearLineList() {
	synchronized(lineList) {
	  lineList.clear();
	}
	repaint();
    }
   
    public void paintComponent (Graphics g) {
      if (true) {
	super.paintComponent(g);
	naviG = (Graphics2D) g;
	synchronized(objList) {
	  ListIterator it = objList.listIterator();
	  while (it.hasNext()) {
		TSObj obj = (TSObj)it.next();
		  plotLoc(obj.x, obj.y, obj.c, obj.e*5.0);
	  }
	}
	synchronized(lineList) {
	  ListIterator it = lineList.listIterator();
	  while (it.hasNext()) {
		TSObj obj = (TSObj)it.next();
		  plotLine(obj.x, obj.y, obj.x2, obj.y2,obj.c,obj.w);
	  }
	}
      }
    }

}
       
